package com.app.kemenhub.jakbanapps.db;

import android.database.Cursor;
import android.database.sqlite.SQLiteDatabase;
import android.database.sqlite.SQLiteStatement;

import de.greenrobot.dao.AbstractDao;
import de.greenrobot.dao.Property;
import de.greenrobot.dao.internal.DaoConfig;

import com.app.kemenhub.jakbanapps.db.disposition;

// THIS CODE IS GENERATED BY greenDAO, DO NOT EDIT.
/** 
 * DAO for table "DISPOSITION".
*/
public class dispositionDao extends AbstractDao<disposition, Long> {

    public static final String TABLENAME = "DISPOSITION";

    /**
     * Properties of entity disposition.<br/>
     * Can be used for QueryBuilder and for referencing column names.
    */
    public static class Properties {
        public final static Property Id = new Property(0, Long.class, "id", true, "_id");
        public final static Property Category_id = new Property(1, String.class, "category_id", false, "CATEGORY_ID");
        public final static Property From = new Property(2, String.class, "from", false, "FROM");
        public final static Property No_surat_perintah = new Property(3, String.class, "no_surat_perintah", false, "NO_SURAT_PERINTAH");
        public final static Property No_agenda = new Property(4, String.class, "no_agenda", false, "NO_AGENDA");
        public final static Property Title = new Property(5, String.class, "title", false, "TITLE");
        public final static Property Desc = new Property(6, String.class, "desc", false, "DESC");
        public final static Property Notes = new Property(7, String.class, "notes", false, "NOTES");
        public final static Property Forward_to_user_id = new Property(8, String.class, "forward_to_user_id", false, "FORWARD_TO_USER_ID");
        public final static Property Cls = new Property(9, String.class, "cls", false, "CLS");
        public final static Property File = new Property(10, String.class, "file", false, "FILE");
        public final static Property Notif = new Property(11, Boolean.class, "notif", false, "NOTIF");
    };


    public dispositionDao(DaoConfig config) {
        super(config);
    }
    
    public dispositionDao(DaoConfig config, DaoSession daoSession) {
        super(config, daoSession);
    }

    /** Creates the underlying database table. */
    public static void createTable(SQLiteDatabase db, boolean ifNotExists) {
        String constraint = ifNotExists? "IF NOT EXISTS ": "";
        db.execSQL("CREATE TABLE " + constraint + "\"DISPOSITION\" (" + //
                "\"_id\" INTEGER PRIMARY KEY ," + // 0: id
                "\"CATEGORY_ID\" TEXT," + // 1: category_id
                "\"FROM\" TEXT," + // 2: from
                "\"NO_SURAT_PERINTAH\" TEXT," + // 3: no_surat_perintah
                "\"NO_AGENDA\" TEXT," + // 4: no_agenda
                "\"TITLE\" TEXT," + // 5: title
                "\"DESC\" TEXT," + // 6: desc
                "\"NOTES\" TEXT," + // 7: notes
                "\"FORWARD_TO_USER_ID\" TEXT," + // 8: forward_to_user_id
                "\"CLS\" TEXT," + // 9: cls
                "\"FILE\" TEXT," + // 10: file
                "\"NOTIF\" INTEGER);"); // 11: notif
    }

    /** Drops the underlying database table. */
    public static void dropTable(SQLiteDatabase db, boolean ifExists) {
        String sql = "DROP TABLE " + (ifExists ? "IF EXISTS " : "") + "\"DISPOSITION\"";
        db.execSQL(sql);
    }

    /** @inheritdoc */
    @Override
    protected void bindValues(SQLiteStatement stmt, disposition entity) {
        stmt.clearBindings();
 
        Long id = entity.getId();
        if (id != null) {
            stmt.bindLong(1, id);
        }
 
        String category_id = entity.getCategory_id();
        if (category_id != null) {
            stmt.bindString(2, category_id);
        }
 
        String from = entity.getFrom();
        if (from != null) {
            stmt.bindString(3, from);
        }
 
        String no_surat_perintah = entity.getNo_surat_perintah();
        if (no_surat_perintah != null) {
            stmt.bindString(4, no_surat_perintah);
        }
 
        String no_agenda = entity.getNo_agenda();
        if (no_agenda != null) {
            stmt.bindString(5, no_agenda);
        }
 
        String title = entity.getTitle();
        if (title != null) {
            stmt.bindString(6, title);
        }
 
        String desc = entity.getDesc();
        if (desc != null) {
            stmt.bindString(7, desc);
        }
 
        String notes = entity.getNotes();
        if (notes != null) {
            stmt.bindString(8, notes);
        }
 
        String forward_to_user_id = entity.getForward_to_user_id();
        if (forward_to_user_id != null) {
            stmt.bindString(9, forward_to_user_id);
        }
 
        String cls = entity.getCls();
        if (cls != null) {
            stmt.bindString(10, cls);
        }
 
        String file = entity.getFile();
        if (file != null) {
            stmt.bindString(11, file);
        }
 
        Boolean notif = entity.getNotif();
        if (notif != null) {
            stmt.bindLong(12, notif ? 1L: 0L);
        }
    }

    /** @inheritdoc */
    @Override
    public Long readKey(Cursor cursor, int offset) {
        return cursor.isNull(offset + 0) ? null : cursor.getLong(offset + 0);
    }    

    /** @inheritdoc */
    @Override
    public disposition readEntity(Cursor cursor, int offset) {
        disposition entity = new disposition( //
            cursor.isNull(offset + 0) ? null : cursor.getLong(offset + 0), // id
            cursor.isNull(offset + 1) ? null : cursor.getString(offset + 1), // category_id
            cursor.isNull(offset + 2) ? null : cursor.getString(offset + 2), // from
            cursor.isNull(offset + 3) ? null : cursor.getString(offset + 3), // no_surat_perintah
            cursor.isNull(offset + 4) ? null : cursor.getString(offset + 4), // no_agenda
            cursor.isNull(offset + 5) ? null : cursor.getString(offset + 5), // title
            cursor.isNull(offset + 6) ? null : cursor.getString(offset + 6), // desc
            cursor.isNull(offset + 7) ? null : cursor.getString(offset + 7), // notes
            cursor.isNull(offset + 8) ? null : cursor.getString(offset + 8), // forward_to_user_id
            cursor.isNull(offset + 9) ? null : cursor.getString(offset + 9), // cls
            cursor.isNull(offset + 10) ? null : cursor.getString(offset + 10), // file
            cursor.isNull(offset + 11) ? null : cursor.getShort(offset + 11) != 0 // notif
        );
        return entity;
    }
     
    /** @inheritdoc */
    @Override
    public void readEntity(Cursor cursor, disposition entity, int offset) {
        entity.setId(cursor.isNull(offset + 0) ? null : cursor.getLong(offset + 0));
        entity.setCategory_id(cursor.isNull(offset + 1) ? null : cursor.getString(offset + 1));
        entity.setFrom(cursor.isNull(offset + 2) ? null : cursor.getString(offset + 2));
        entity.setNo_surat_perintah(cursor.isNull(offset + 3) ? null : cursor.getString(offset + 3));
        entity.setNo_agenda(cursor.isNull(offset + 4) ? null : cursor.getString(offset + 4));
        entity.setTitle(cursor.isNull(offset + 5) ? null : cursor.getString(offset + 5));
        entity.setDesc(cursor.isNull(offset + 6) ? null : cursor.getString(offset + 6));
        entity.setNotes(cursor.isNull(offset + 7) ? null : cursor.getString(offset + 7));
        entity.setForward_to_user_id(cursor.isNull(offset + 8) ? null : cursor.getString(offset + 8));
        entity.setCls(cursor.isNull(offset + 9) ? null : cursor.getString(offset + 9));
        entity.setFile(cursor.isNull(offset + 10) ? null : cursor.getString(offset + 10));
        entity.setNotif(cursor.isNull(offset + 11) ? null : cursor.getShort(offset + 11) != 0);
     }
    
    /** @inheritdoc */
    @Override
    protected Long updateKeyAfterInsert(disposition entity, long rowId) {
        entity.setId(rowId);
        return rowId;
    }
    
    /** @inheritdoc */
    @Override
    public Long getKey(disposition entity) {
        if(entity != null) {
            return entity.getId();
        } else {
            return null;
        }
    }

    /** @inheritdoc */
    @Override    
    protected boolean isEntityUpdateable() {
        return true;
    }
    
}
